<?php
class AuthController extends My_Controller_Action {

	function init() {
		parent::init();
	}

	function indexAction() {
		$this->_redirect('/');
	}

	function loginAction() {
		$this->view->message = '';
		$form = new Default_Form_AuthLogin();
		if($this->validForm($form)) {
			$values = $form->getValues();
			$authAdapter = new Zend_Auth_Adapter_DbTable(Zend_Db_Table::getDefaultAdapter());
			$authAdapter
			->setTableName('Users')
			->setIdentityColumn('Email')
			->setIdentity($values['Email'])
			->setCredentialColumn('Password')
			->setCredential(sha1($values['Password']));
				
			// kolla om det är OK
			$auth = Zend_Auth::getInstance();
			$result = $auth->authenticate($authAdapter);
			if ($result->isValid()) {
				// success: Sparar database row till auth's storage system. (Dock inte lösenordet!)
				$data = $authAdapter->getResultRowObject(null,'Password');
				$auth->getStorage()->write($data);
				$this->_redirect('/user');
			} else {
				$this->view->message = 'Felaktigt lösenord eller email.';
				$this->view->form = $form->render();
			}
		}


	}

	function logoutAction() {
		Zend_Auth::getInstance()->clearIdentity();
		$this->_redirect('/');
	}

	function lostpasswordAction() {
		$form = new Default_Form_AuthLostPassword();
		if($this->validForm($form)) {
			$values = $form->getValues();
			$class = new Default_Model_Users();
			$user = $class->fetchRow("Deleted = 0 AND Email = '". $values['Email'] ."'");
			if(empty($user)) {
				$this->_redirect('/auth/info/info/nouser');
			} else {
				$key = sha1($user->UserID . $user->Password);

				$mail = new Zend_Mail('utf-8');
				$mail->addTo($values['Email']);
				$mail->setFrom(MAILFROM,MAILFROMNAME);
				$mail->setSubject('Begäran av nytt lösenord');
				$mail->setBodyText("Någon förhoppningsvis du har begärt en länk för att sätt ett nytt lösenord.\n\n---\nHär kommer en länk där du kan sätta ett nytt lösenord: \n".
				'http://' . $_SERVER['HTTP_HOST'] .WEBPATH. '/auth/newpassword/key/'. $key);
				$mail->send();
				$this->_redirect('/auth/info/info/mail');
			}
		}
	}

	function infoAction() {
		$info = $this->_request->getParam('info','');
		switch ($info) {
			case 'mail':
				$this->view->success = 'E-post för att byta lösenord är skickat.';
				$this->view->head = 'Kolla din e-post.';
				$this->view->message = 'Du har fått ett e-brev med en länk, från den länken kan du om du vill sätt ett nytt lösenord.';
				break;
			case 'change':
				$this->view->success = "Lösenordet godkänt.";
				$this->view->message = 'Nu kan du logga in!';
				break;
			case 'key':
				$this->view->error = "Felaktig nyckel!";
				$this->view->head = 'OBS!';
				$this->view->message = 'Du kanske inte har fått med hela länken i ditt mail, kolla om det är så! <br/> Pröva annars med att hämta ett nytt mail!';
				break;
			case 'nouser':
				$this->view->error = 'E-post adressen finns inte i vårt register.';
				$this->view->head = 'Finns ej';
				$this->view->message = 'Den e-postadress du angav finns in hos oss!';
				break;
			default:
				$this->view->error = 'Okänt fel...';
				$this->view->head = 'Pröva igen!';
				$this->view->message = 'Funkar det inte kontakta någon ansvarig...';
				break;
		}
	}

	function newpasswordAction() {
		$key = $this->_request->getParam('key',0);
		$class = new Default_Model_Users();
		$user = $class->fetchRow("Deleted = 0 AND SHA1(CONCAT(UserID,Password)) = '". $key ."'");
		if(empty($user)) {
			$this->_redirect('/auth/info/info/key');
		} else {
			$form = new Default_Form_AuthNewPassword();
			if($this->validForm($form)) {
				$values = $form->getValues();
				$user->Password = sha1($values['Password']);
				$user->save();
				$this->_redirect('/auth/info/info/change');
			}
		}
	}
}
