<?php
class ErrorController extends My_Controller_Action {

	public function errorAction()	{
		$errors = $this->_getParam('error_handler');

		// Lista på felaktiga controllers som inte är fel...
		$controllers = array (
				'_vti_bin',
				'MSOffice',
		);

		switch ($errors->type) {
			case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_CONTROLLER:
			case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ACTION:
				// 404 error -- controller or action not found
				$this->getResponse()
				->setRawHeader('HTTP/1.1 404 Not Found');

				break;
			default:
				// application error; display error page, but don't
				// change status code
				break;
		}
		// Kolla om felaktiga controllers finns i listan för sådana som inte är fel....
		foreach ($controllers as $controller) {
			if (false !== strpos($errors->exception->getMessage(), $controller)) {
				$this->_redirect('/');
				return;
			}
		}

		// Skapar ett felmeddelande...
		$message =	'Exception information from: ' . get_class($errors->exception) .'
Message:' . $errors->exception->getMessage() .'

Stack trace: 
' . $errors->exception->getTraceAsString() .'

Request Parameters:
'. var_export($errors->request->getParams(), true) .'

Från $_SERVER
'.  var_export($_SERVER, true);

		// Kollar om man skall visa eller skicka mail...
		if(DEBUG) {
			$this->view->errors = $message;
		} else {
			$mail = new Zend_Mail('utf-8');
			$mail->setBodyText($message);
			$mail->setFrom(DEBUGMAIL, 'MyTest - Error');
			$mail->addTo(DEBUGMAIL);
			$mail->setSubject(MAILFROMNAME . ' - MyErrorController');
			$mail->send();
		}
		return;
	}
}
