<?php

class Default_Form_UserChange extends My_Form {
	
	private $id;

	public function __construct($id = 0) 	{
		$this->id = $id;
		parent::__construct();
	}

	public function init() {
		$firstname = new Zend_Form_Element_Text('FirstName');
		$firstname
			->setRequired(true)
			->addValidator('Alpha')
			->setLabel('Förnamn:');

		$lastname = new Zend_Form_Element_Text('LastName');
		$lastname
			->setRequired(true)
			->addValidator('Alpha')
			->setLabel('Efternamn:');

		$email = new Zend_Form_Element_Text('Email');
		$email
			->addValidator('EmailAddress')
			->setRequired(true)
			->setLabel('E-postadress:');

		$submit = new Zend_Form_Element_Submit('submit');
		$submit
			->setLabel('Spara');
		
		// Lägger in värden om man skall ändra
		$legend = 'Lägg till en ny användare';
		if ($this->id) {
			$class = new Default_Model_Users();
			$data = $class->fetchRow('UserID = ' . $this->id);
			$firstname->setValue(stripcslashes($data->FirstName));
			$lastname->setValue(stripcslashes($data->LastName));
			$email->setValue($data->Email);
			$legend = 'Ändra ' . $data->FirstName . ' ' . $data->LastName; 
		}
		
		$this->setAction(WEBPATH.'/user/change/id/' . $this->id)
			->setMethod('post')
			->addElements(array($firstname, $lastname, $email, $submit))
			->addDisplayGroup(array('FirstName', 'LastName', 'Email', 'submit'), 'MY', array("legend" => $legend));
	}
}
