 <?php
/**
 * Hittade denna kod, har saknat just denna validator...
 * 
 * Checks if a field has the same value as another,
 * very useful in validating passwords
 *
 * @package My Validate
 * @author Tudor Barbu <miau@motane.lu>
 * @copyright MIT
 */

class My_Validate_SameAs extends Zend_Validate_Abstract {
	/**
	 * Validation failure message key for when the values are not
	 * the same
	 */
	const NOT_THE_SAME = 'not_the_same';

	/**
	 * the external element that we check the value against
	 *
	 * @var Zend_Form_Element
	 */
	protected $_element;

	/**
	 * Validation failure message template definitions
	 *
	 * @var array
	 */
	protected $_messageTemplates = array(
	self::NOT_THE_SAME => 'The two values are not identical',
	);

	/**
	 * Can receive a Zend_Form_Element parameter that will be used
	 * into the validation process
	 *
	 * @param Zend_Form_Element
	 */
	public function __construct(Zend_Form_Element $element = null) {
		if(null !== $element) {
			$this->setElement($element);
		}
	}

	/**
	 * set the element
	 *
	 * @param Zend_Form_Element $element
	 * @return void
	 */
	public function setElement(Zend_Form_Element $element) {
		$this->_element = $element;
	}

	/**
	 * gets the element
	 *
	 * @return Zend_Form_Element
	 */
	public function getElement() {
		return $this->_element;
	}

	/**
	 * overrides isValid from Zend_Validate_Interface
	 *
	 * @param string $value
	 * @return bool
	 */
	public function isValid($value) {
		if(null === $this->_element) {
			require_once 'Zend/Exception.php';
			throw new Zend_Exception('You must add a Zend_Form_Element to the SameAs validator prior to calling the isValid() method');
		}

		if($value != $this->_element->getValue()) {
			$this->_error(self::NOT_THE_SAME);
			return false;
		}

		return true;
	}
}