<?php
// Define path to application directory
defined('APPLICATION_PATH')
    || define('APPLICATION_PATH', realpath(dirname(__FILE__) . '/../application'));

// Define application environment
defined('APPLICATION_ENV')
    || define('APPLICATION_ENV', (getenv('APPLICATION_ENV') ? getenv('APPLICATION_ENV') : 'production'));


set_include_path(implode(PATH_SEPARATOR, array(
    realpath(APPLICATION_PATH . '/../library'),
    get_include_path(),
)));


require_once 'Zend/Application.php';  

// Skapa applikationen och kör bootstrap
$application = new Zend_Application(
    APPLICATION_ENV, 
    APPLICATION_PATH . '/configs/application.ini'
);
$application->bootstrap();
$application->getAutoloader()->registerNamespace(array('My_'));

// Lägger in define från config-filen
$my_define = $application->getOption('define');
foreach ($my_define as $name => $value) {
	define($name,$value);
}

//  Databasen 
$db_config = $application->getOption('db');
$db = Zend_Db::factory($db_config['adapter'], $db_config['config']);
$db->query('set NAMES utf8');
Zend_Db_Table::setDefaultAdapter($db);

// Starta
$application->run();

// DEBUG: visar alla frågor som körs om DEBUG=true och alla SQL-frågor om profiler=true
if ($db_config['config']['profiler'] && DEBUG) {
	include('../application/includes/queryinfo.php');
}	

